
<!-- README.md is generated from README.Rmd. Please edit that file -->

# Surrogate

<!-- badges: start -->

[![R-CMD-check](https://github.com/florianstijven/Surrogate-development/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/florianstijven/Surrogate-development/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

In a clinical trial, it frequently occurs that the most credible outcome
to evaluate the effectiveness of a new therapy (the true endpoint) is
difficult to measure. In such a situation, it can be an effective
strategy to replace the true endpoint by a (bio)marker that is easier to
measure and that allows for a prediction of the treatment effect on the
true endpoint (a surrogate endpoint). The package ‘Surrogate’ allows for
an evaluation of the appropriateness of a candidate surrogate endpoint
based on the meta-analytic, information-theoretic, and causal-inference
frameworks. Part of this software has been developed using funding
provided from the European Union’s Seventh Framework Programme for
research, technological development and demonstration (Grant Agreement
no 602552), the Special Research Fund (BOF) of Hasselt University
(BOF-number: BOF2OCPO3), GlaxoSmithKline Biologicals, Baekeland Mandaat
(HBC.2022.0145), and Johnson & Johnson Innovative Medicine.

## Installation

You can install the development version of Surrogate from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("florianstijven/Surrogate-development")
```
